﻿using System;



namespace Math3D
{
    public static class Vector
    {
        public static void set(double[] v, double x, double y, double z)
        {
            v[0] = x;
            v[1] = y;
            v[2] = z;

        }
        public static void mul_vec(double[] dest, double[] src, double factor)
        {
            dest[0] = src[0]* factor;
            dest[1] = src[1] * factor;
            dest[2] = src[2] * factor;
        }

        public static void mul_vec(double[] dest, double factor)
        {
            mul_vec(dest, dest, factor);
        }

        public static void add_vec(double[] vec, double[] addition)
        {
            vec[0] = vec[0] + addition[0];
            vec[1] = vec[1] + addition[1];
            vec[2] = vec[2] + addition[2];
        }

        public static void sub_vec(double[] vec, double[] subtract)
        {
            vec[0] = vec[0] - subtract[0];
            vec[1] = vec[1] - subtract[1];
            vec[2] = vec[2] - subtract[2];
        }

        public static void copy(double[] vec, double[] src)
        {
            vec[0] = src[0];
            vec[1] = src[1];
            vec[2] = src[2];
        }

        public static double[] copy(double[] src)
        {
            double[] vec = new double[3];
            
            vec[0] = src[0];
            vec[1] = src[1];
            vec[2] = src[2];

            return (vec);
        }

        public static double square_length(double[] v1)
        {
            return (v1[0] * v1[0] + v1[1] * v1[1] + v1[2] * v1[2]);
        }


        public static bool is_equal(double[] v1, double[] v2, double threshold)
        {
            
            double[] v3 = copy(v1);

            sub_vec(v3, v2);

            double sq_length = square_length(v3);

            if (sq_length <= threshold * threshold)
                return (true);

            return (false);

        }


        public static double distance_between_points(double[] p1, double[] p2)
        {
            double square_distance = square_distance_between_points(p1, p2);
            return (Math.Sqrt(square_distance));
        }

        public static double square_distance_between_points(double[] p1, double[] p2)
        {
            double[] vec = copy(p2);
            sub_vec(vec, p1);

            double square_distance = vec[0] * vec[0] + vec[1] * vec[1] + vec[2] * vec[2];
            return (square_distance);


        }


    }

}