﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

using _3dstate;



namespace OneAgainst100Planes
{

    public partial class Game : Form
    {
        Level[] m_levels = { 
                //Very friendly (1-5)
                new Level("Let's get started !",         0, ModelIndex.SU37,         ModelIndex.Piper, AI.Plane, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryFriendly,          EnemyPlanes.Ten, EnemyTanks.Zero, Mission.Kill_5_Planes, Mission.Kill_0_Tanks), //level 0
                new Level("5 planes in 3 minutes !",    3, ModelIndex.Junkers52,    ModelIndex.Piper, AI.Plane, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryFriendly,  EnemyPlanes.Ten, EnemyTanks.Zero, Mission.Kill_5_Planes, Mission.Kill_0_Tanks), //level 1. add time limit and aggression
                new Level("The evil fairy has no mercy",             0, ModelIndex.Mig29,        ModelIndex.Fairy, AI.Insect, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryFriendly,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_5_Planes, Mission.Kill_0_Tanks),
                new Level("The tanks are coming !",     5, ModelIndex.Ling,         ModelIndex.Piper, AI.Plane, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryFriendly,            EnemyPlanes.Five, EnemyTanks.Twenty, Mission.Kill_3_Planes, Mission.Kill_10_Tanks), //level 2
                new Level("It's like shooting ducks !",         6, ModelIndex.SU37,         ModelIndex.Piper, AI.None, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryFriendly,          EnemyPlanes.Thirty, EnemyTanks.Zero, Mission.Kill_20_Planes, Mission.Kill_0_Tanks), //level 0

                //friendly (6-10)
                new Level("One on one !",               0, ModelIndex.Piper,        ModelIndex.Piper, AI.Plane, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Friendly,EnemyPlanes.One, EnemyTanks.Zero, Mission.Kill_1_Plane, Mission.Kill_0_Tanks), //level 3. one on one
                new Level("One against 5 !",          0, ModelIndex.Junkers88,      ModelIndex.Piper, AI.Plane, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Friendly,  EnemyPlanes.Five, EnemyTanks.Zero, Mission.Kill_5_Planes, Mission.Kill_0_Tanks), 
                new Level("One against 10 !",          0, ModelIndex.F16,           ModelIndex.Junkers52, AI.Plane, EnemyShootingStyle.Random, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Friendly,  EnemyPlanes.Ten, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks), 

                new Level("5 planes in 2 minutes !",    2, ModelIndex.Junkers52,    ModelIndex.Piper, AI.Plane, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Friendly,  EnemyPlanes.Ten, EnemyTanks.Zero, Mission.Kill_5_Planes, Mission.Kill_0_Tanks),
                new Level("The tank shredder !",     3, ModelIndex.Ling,         ModelIndex.Piper, AI.Plane, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Friendly,  EnemyPlanes.Five, EnemyTanks.Twenty, Mission.Kill_3_Planes, Mission.Kill_10_Tanks),

                //slightly friendly (11-13)
                new Level("a worthy rival !",          0, ModelIndex.Mig29,        ModelIndex.F16, AI.Plane, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.SlightlyFriendly,EnemyPlanes.One, EnemyTanks.Zero, Mission.Kill_1_Plane, Mission.Kill_0_Tanks), 
                new Level("and now 5 !",               0, ModelIndex.SU37,        ModelIndex.F16, AI.Plane, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.SlightlyFriendly,EnemyPlanes.Five, EnemyTanks.Zero, Mission.Kill_5_Planes, Mission.Kill_0_Tanks), 
                new Level("Can you beat 10 ?",          0, ModelIndex.Piper,        ModelIndex.F16, AI.Plane, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.SlightlyFriendly,EnemyPlanes.Ten, EnemyTanks.Zero, Mission.Kill_5_Planes, Mission.Kill_0_Tanks), 

                //Normal (14-20)
                new Level("The Giant Bat is angry",             5, ModelIndex.Blackbird, ModelIndex.Bat, AI.Insect, EnemyShootingStyle.Random,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Normal, EnemyPlanes.One, EnemyTanks.Zero, Mission.Kill_1_Plane, Mission.Kill_0_Tanks),
                new Level("The Killer Flies are blood thirsty", 0, ModelIndex.F16,      ModelIndex.Fly, AI.Insect, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Normal,  EnemyPlanes.Ten, EnemyTanks.Zero, Mission.Kill_5_Planes, Mission.Kill_0_Tanks),

                new Level("A biological experiment that went bad", 4, ModelIndex.A10,   ModelIndex.Dino, AI.Insect, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Normal,  EnemyPlanes.Ten, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),
                new Level("The violent dragonfly",              3, ModelIndex.Mig29,      ModelIndex.Dragonfly, AI.Insect, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Normal,  EnemyPlanes.Ten, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),
                
                new Level("The evil fairy",                     3, ModelIndex.Mig29,    ModelIndex.Fairy, AI.Insect, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Normal,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),

                new Level("One against 30",                     5, ModelIndex.Junkers88,    ModelIndex.Ling, AI.None, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Normal,  EnemyPlanes.Thirty, EnemyTanks.Zero, Mission.Kill_20_Planes, Mission.Kill_0_Tanks),
                new Level("These well protected tanks !",     3, ModelIndex.Stealth,         ModelIndex.A10, AI.Plane, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Normal,  EnemyPlanes.Thirty, EnemyTanks.Twenty, Mission.Kill_3_Planes, Mission.Kill_10_Tanks),

                //SlightlyAggressive (21-27)
                new Level("The Giant Bat wants revenge",             5, ModelIndex.Blackbird, ModelIndex.Bat, AI.Insect, EnemyShootingStyle.Random,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.SlightlyAggressive, EnemyPlanes.One, EnemyTanks.Zero, Mission.Kill_1_Plane, Mission.Kill_0_Tanks),
                new Level("The Killer Flies came for payback", 0, ModelIndex.F16,      ModelIndex.Fly, AI.Insect, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.SlightlyAggressive,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_5_Planes, Mission.Kill_0_Tanks),

                new Level("Pterosauruses will eat you alive", 4, ModelIndex.Junkers52,   ModelIndex.Dino, AI.Insect, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Small, EnemyAggression.SlightlyAggressive,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),
                new Level("The dragonflies are back",              3, ModelIndex.SU37,      ModelIndex.Dragonfly, AI.Insect, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.SlightlyAggressive,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),
                
                new Level("The giant evil fairy",                     3, ModelIndex.Mig29,    ModelIndex.Fairy, AI.Insect, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Huge, EnemyAggression.SlightlyAggressive,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),

                new Level("One against 30. Take 2",                     5, ModelIndex.Junkers88,    ModelIndex.Ling, AI.None, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.SlightlyAggressive,  EnemyPlanes.Thirty, EnemyTanks.Zero, Mission.Kill_20_Planes, Mission.Kill_0_Tanks),
                new Level("These well protected tanks !",     3, ModelIndex.Stealth,         ModelIndex.Mig29, AI.Plane, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.SlightlyAggressive,  EnemyPlanes.Thirty, EnemyTanks.Ten, Mission.Kill_3_Planes, Mission.Kill_5_Tanks),

                //Aggressive (28-30)
                new Level("Back to World War II",             5, ModelIndex.Junkers52, ModelIndex.Piper, AI.Plane, EnemyShootingStyle.Straight,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Aggressive, EnemyPlanes.Five, EnemyTanks.Zero, Mission.Kill_5_Planes, Mission.Kill_0_Tanks),
                new Level("Just 2 minutes to complete the mission", 2, ModelIndex.Junkers88,      ModelIndex.Junkers52, AI.Plane, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Aggressive,  EnemyPlanes.Fifty, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),

                new Level("No rest for the wicked", 3, ModelIndex.Mig29,      ModelIndex.Junkers88, AI.Plane, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Aggressive,  EnemyPlanes.Fifty, EnemyTanks.Ten, Mission.Kill_10_Planes, Mission.Kill_5_Tanks),

                //VeryAggressive (31-35)
                new Level("One on one with The Giant Bat",             5, ModelIndex.Dino, ModelIndex.Bat, AI.Insect, EnemyShootingStyle.Random,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive, EnemyPlanes.One, EnemyTanks.Zero, Mission.Kill_1_Plane, Mission.Kill_0_Tanks),
                new Level("The Killer Flies come for payback", 0, ModelIndex.Fairy,      ModelIndex.Fly, AI.Insect, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_5_Planes, Mission.Kill_0_Tanks),

                new Level("The little fly is in trouble", 4, ModelIndex.Fly,   ModelIndex.Dino, AI.Insect, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.BelowNormal, EnemyAggression.VeryAggressive,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),
                new Level("The dragonflies are back",              3, ModelIndex.SU37,      ModelIndex.Dragonfly, AI.Insect, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),
                
                new Level("Kill the fairies to break the spell",                     2, ModelIndex.Dino,    ModelIndex.Fairy, AI.Insect, EnemyShootingStyle.Straight, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),


                //from now on it is all AimOnPlayer
                //-----------------------------------

                //slightly friendly (36-38)
                new Level("The enemy shifts gears",          5, ModelIndex.Mig29,        ModelIndex.F16, AI.Plane, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.SlightlyFriendly,EnemyPlanes.One, EnemyTanks.Zero, Mission.Kill_1_Plane, Mission.Kill_0_Tanks), 
                new Level("Heavy fire power",               5, ModelIndex.SU37,        ModelIndex.F16, AI.Plane, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.SlightlyFriendly,EnemyPlanes.Five, EnemyTanks.Zero, Mission.Kill_5_Planes, Mission.Kill_0_Tanks), 
                new Level("Stepping it up",          5, ModelIndex.SU37,        ModelIndex.F16, AI.Plane, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.SlightlyFriendly,EnemyPlanes.Ten, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks), 

                //Normal (39-45)
                new Level("You can't hide from the Giant Bat sonar",             5, ModelIndex.Blackbird, ModelIndex.Bat, AI.Insect, EnemyShootingStyle.Random,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Normal, EnemyPlanes.One, EnemyTanks.Zero, Mission.Kill_1_Plane, Mission.Kill_0_Tanks),
                new Level("Can't get rid of these flies", 0, ModelIndex.F16,      ModelIndex.Fly, AI.Insect, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Normal,  EnemyPlanes.Ten, EnemyTanks.Zero, Mission.Kill_5_Planes, Mission.Kill_0_Tanks),

                new Level("Dinosaurs are not what they used to be", 4, ModelIndex.A10,   ModelIndex.Dino, AI.Insect, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Normal,  EnemyPlanes.Ten, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),
                new Level("Dragonflies are there to kill you",              3, ModelIndex.Mig29,      ModelIndex.Dragonfly, AI.Insect, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Normal,  EnemyPlanes.Ten, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),
                
                new Level("The evil fairy has more fire power",                     3, ModelIndex.Mig29,    ModelIndex.Fairy, AI.Insect, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Normal,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),

                new Level("One against 50. Take 2",                     5, ModelIndex.Junkers88,    ModelIndex.Ling, AI.None, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Normal,  EnemyPlanes.Fifty, EnemyTanks.Zero, Mission.Kill_20_Planes, Mission.Kill_0_Tanks),
                new Level("Hunting tanks while under fire",     3, ModelIndex.Stealth,         ModelIndex.Mig29, AI.Plane, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Normal,  EnemyPlanes.Thirty, EnemyTanks.Ten, Mission.Kill_3_Planes, Mission.Kill_5_Tanks),

                //SlightlyAggressive (46-52)
                new Level("The Giant Bat is back with more power",             5, ModelIndex.Blackbird, ModelIndex.Bat, AI.Insect, EnemyShootingStyle.Random,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.SlightlyAggressive, EnemyPlanes.One, EnemyTanks.Zero, Mission.Kill_1_Plane, Mission.Kill_0_Tanks),
                new Level("The Killer Flies are not letting go", 0, ModelIndex.F16,      ModelIndex.Fly, AI.Insect, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.SlightlyAggressive,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_5_Planes, Mission.Kill_0_Tanks),

                new Level("Pterosauruses are doing WW2", 4, ModelIndex.Junkers52,   ModelIndex.Dino, AI.Insect, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Small, EnemyAggression.SlightlyAggressive,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),
                new Level("The dragonflies are back",              3, ModelIndex.SU37,      ModelIndex.Dragonfly, AI.Insect, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.SlightlyAggressive,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),
                
                new Level("The giant evil fairy",                     3, ModelIndex.Mig29,    ModelIndex.Fairy, AI.Insect, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Huge, EnemyAggression.SlightlyAggressive,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),

                new Level("One against 50. Take 3",                     5, ModelIndex.Junkers88,    ModelIndex.Ling, AI.None, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.SlightlyAggressive,  EnemyPlanes.Fifty, EnemyTanks.Zero, Mission.Kill_20_Planes, Mission.Kill_0_Tanks),
                new Level("Under heavy fire !",     3, ModelIndex.Stealth,         ModelIndex.F16, AI.Plane, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.SlightlyAggressive,  EnemyPlanes.Thirty, EnemyTanks.Ten, Mission.Kill_3_Planes, Mission.Kill_5_Tanks),

                //Aggressive (53-55)
                new Level("World war II with firepower of WW4 ",             5, ModelIndex.Junkers52, ModelIndex.Piper, AI.Plane, EnemyShootingStyle.AimOnPlayer,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Aggressive, EnemyPlanes.Five, EnemyTanks.Zero, Mission.Kill_5_Planes, Mission.Kill_0_Tanks),
                new Level("2 minutes is not a lot of time", 2, ModelIndex.Junkers88,      ModelIndex.Junkers52, AI.Plane, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Aggressive,  EnemyPlanes.Fifty, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),

                new Level("Tanks and planes can get you drained", 3, ModelIndex.Mig29,      ModelIndex.Junkers88, AI.Plane, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.Aggressive,  EnemyPlanes.Fifty, EnemyTanks.Ten, Mission.Kill_10_Planes, Mission.Kill_5_Tanks),

                //VeryAggressive (56-60)
                new Level("Only the best get to this level",             5, ModelIndex.Dino, ModelIndex.Bat, AI.Insect, EnemyShootingStyle.Random,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive, EnemyPlanes.One, EnemyTanks.Zero, Mission.Kill_1_Plane, Mission.Kill_0_Tanks),
                new Level("We admire your skills", 0, ModelIndex.Fairy,      ModelIndex.Fly, AI.Insect, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_5_Planes, Mission.Kill_0_Tanks),

                new Level("The little fly needs you !", 4, ModelIndex.Fly,   ModelIndex.Dino, AI.Insect, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.BelowNormal, EnemyAggression.VeryAggressive,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),
                new Level("The dragonflies have no respect",              3, ModelIndex.SU37,      ModelIndex.Dragonfly, AI.Insect, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),
                
                new Level("See if you can pass this level !!!",                     2, ModelIndex.Dino,    ModelIndex.Fairy, AI.Insect, EnemyShootingStyle.AimOnPlayer, EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive,  EnemyPlanes.Twenty, EnemyTanks.Zero, Mission.Kill_10_Planes, Mission.Kill_0_Tanks),


                //The final stage ! make it harder and harder till it is impossible
                //VeryAggressive (61-74)
                new Level("It's the final showdown",             4, ModelIndex.Junkers52, ModelIndex.Piper, AI.Plane, EnemyShootingStyle.AimOnPlayer,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive, EnemyPlanes.Fifty, EnemyTanks.Zero, Mission.Kill_20_Planes, Mission.Kill_0_Tanks),
                new Level("You are among the best !",             5, ModelIndex.Junkers88, ModelIndex.Junkers52, AI.Plane, EnemyShootingStyle.AimOnPlayer,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive, EnemyPlanes.Fifty, EnemyTanks.Ten, Mission.Kill_20_Planes, Mission.Kill_5_Tanks),

                new Level("Have you thought about games as a profession ?",             3.5, ModelIndex.F16, ModelIndex.Junkers88, AI.Plane, EnemyShootingStyle.AimOnPlayer,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive, EnemyPlanes.Hundred, EnemyTanks.Zero, Mission.Kill_20_Planes, Mission.Kill_0_Tanks),
                new Level("You must be a real fighter pilot !",             4.5, ModelIndex.Mig29, ModelIndex.F16, AI.Plane, EnemyShootingStyle.AimOnPlayer,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive, EnemyPlanes.Fifty, EnemyTanks.Ten, Mission.Kill_20_Planes, Mission.Kill_5_Tanks),
                
                new Level("Oh my God, you rock !!!",             3, ModelIndex.F16, ModelIndex.Junkers88, AI.Plane, EnemyShootingStyle.AimOnPlayer,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive, EnemyPlanes.Hundred, EnemyTanks.Zero, Mission.Kill_20_Planes, Mission.Kill_0_Tanks),
                new Level("You are on your way to become number 1",             4, ModelIndex.Mig29, ModelIndex.F16, AI.Plane, EnemyShootingStyle.AimOnPlayer,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive, EnemyPlanes.Hundred, EnemyTanks.Ten, Mission.Kill_20_Planes, Mission.Kill_5_Tanks),

                new Level("Oh my God, you rock !!!",             2.5, ModelIndex.SU37, ModelIndex.Mig29, AI.Plane, EnemyShootingStyle.AimOnPlayer,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive, EnemyPlanes.Hundred, EnemyTanks.Zero, Mission.Kill_20_Planes, Mission.Kill_0_Tanks),
                new Level("You are on your way to become number 1",             3.5, ModelIndex.Stealth, ModelIndex.F16, AI.Plane, EnemyShootingStyle.AimOnPlayer,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive, EnemyPlanes.Hundred, EnemyTanks.Ten, Mission.Kill_20_Planes, Mission.Kill_5_Tanks),
                
                new Level("You are very close to finish the game",             2, ModelIndex.Mig29, ModelIndex.F16, AI.Plane, EnemyShootingStyle.AimOnPlayer,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive, EnemyPlanes.Hundred, EnemyTanks.Zero, Mission.Kill_20_Planes, Mission.Kill_0_Tanks),
                new Level("AI cannot handle your skills",             3, ModelIndex.F16, ModelIndex.Mig29, AI.Plane, EnemyShootingStyle.AimOnPlayer,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive, EnemyPlanes.Hundred, EnemyTanks.Ten, Mission.Kill_20_Planes, Mission.Kill_5_Tanks),

                new Level("We didnt think anyone will get here at all !",             1.5, ModelIndex.Mig29, ModelIndex.F16, AI.Plane, EnemyShootingStyle.AimOnPlayer,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive, EnemyPlanes.Hundred, EnemyTanks.Zero, Mission.Kill_20_Planes, Mission.Kill_0_Tanks),
                new Level("Wow, you are some super machine !",             2.5, ModelIndex.F16, ModelIndex.A10, AI.Plane, EnemyShootingStyle.AimOnPlayer,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive, EnemyPlanes.Hundred, EnemyTanks.Ten, Mission.Kill_20_Planes, Mission.Kill_5_Tanks),

                new Level("The final frontier !",             1, ModelIndex.Mig29, ModelIndex.F16, AI.Plane, EnemyShootingStyle.AimOnPlayer,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive, EnemyPlanes.Hundred, EnemyTanks.Zero, Mission.Kill_20_Planes, Mission.Kill_0_Tanks),
                new Level("The last level !!!",             2, ModelIndex.F16, ModelIndex.Mig29, AI.Plane, EnemyShootingStyle.AimOnPlayer,EnemySpeed.Normal, EnemySize.Normal, EnemyAggression.VeryAggressive, EnemyPlanes.Hundred, EnemyTanks.Ten, Mission.Kill_20_Planes, Mission.Kill_5_Tanks),


        };
    }


    //for the sake of code readability we define several enums
    public enum EnemyPlanes { One=1, Five = 5, Ten = 10, Twenty=20,  Thirty=30,Fifty = 50, Hundred=100 };
    public enum EnemyTanks { Zero = 0, Five = 5, Ten = 10, Twenty=20, Fifty = 50 };
    public enum Mission { Kill_0_Tanks = 0, Kill_0_Planes = 0, Kill_1_Tank = 1, Kill_1_Plane = 1, Kill_3_Planes = 3, Kill_5_Planes = 5, Kill_5_Tanks = 5, Kill_10_Planes = 10, Kill_10_Tanks = 10, Kill_20_Planes = 20, Kill_20_Tanks = 20, Kill_30_Planes = 30, Kill_30_Tanks = 30 };
    //EnemySpeed = the percentage of speed increase from the default
    public enum EnemySpeed { VerySlow=25, Slow=50, BelowNormal=75, Normal=100, AboveNormal=125, Fast=150, VeryFast=200};
    //EnemySize = percentage of increased sized from the normal size
    public enum EnemySize { VerySmall=25, Small=50, BelowNormal=75, Normal=100, AboveNormal=125, Big=150, VeryBig=200, Huge=500, Giant=1000 };
    //EnemyAggression = the dealy in milli seconds before the enemy attacks. for example 1000 means that every one second (1000 milliseconds) one enemy will change its track's next point to the player location
    public enum EnemyAggression { VeryFriendly=10000, Friendly=5000, SlightlyFriendly=3000 ,Normal=1000, SlightlyAggressive=500, Aggressive=250, VeryAggressive=100, Killer=0};
    
    public enum ObjectType { Unknown = 0, Bomb = 1, Missile = 2, Plane = 3, Tank = 4, Killed = 5 };

    //Stright means in the direction of movement
    //Random means one of three (Stright, Up or Down)
    //AimOnPlayer means the enemy shoot directly on the player regardless of its position. i.e. it is free to shoot in all directions !
    public enum EnemyShootingStyle {Straight=1, Down=2, Up=3, Random=4, AimOnPlayer=5 };


    public class Level
    {
        //models that are set explicitly for every level
        public Model player_plane;
        public Model player_missile;
        public Model enemy_plane;
        public uint enemy_missile_obj; //if ModelIndex.None we will use a resuzed shape of the enemy_model as the missile
        public AI enemy_AI;
        public EnemyShootingStyle enemy_shooting_style;
        double default_enemy_speed = 25000;
        public double enemy_speed;
        EnemySize enemy_size;
        public double enemy_firing_delay;

        public string level_name;
        public int number_of_enemy_planes;
        public int number_of_enemy_tanks;
        public int number_of_enemy_planes_to_kill; //how many need to be shot down in order to get to the next level
        public int number_of_enemy_tanks_to_kill; //how many need to be shot down in order to get to the next level

        public double level_time_limit_in_minutes;
        public DateTime level_start_time;

        //default models
        public Model bomb = AllModels.models[(int)ModelIndex.Bomb];
        public Model explosion = AllModels.models[(int)ModelIndex.Explosion];
        public Model tank = AllModels.models[(int)ModelIndex.Tank];
        public Model tank_destroyed = AllModels.models[(int)ModelIndex.TankDestroyed];
        public Model alternative_plane = AllModels.models[(int)ModelIndex.Piper];

        //auto generated values
        public string level_text; //the text at the beginning "well done. Get ready for your next mission. Shoot down 10 planes and destroy 10 tanks ...
        public List<uint> text3D_objects;

        string[] well_done_texts = {"Good Job !", "Well Done !", "Captin, you made it !", "You did a good job !", "Great, Couldn't have done it better myself !", "Great !"};
        int level_number; //the first one is 1
        static int number_of_levels=0;
        Random rnd = new Random(DateTime.Now.Millisecond);

        

        public Level(string level_name_str, double time_limit_in_minutes,  ModelIndex pl_model, ModelIndex en_model, AI en_artificial_inteligence, EnemyShootingStyle en_shooting_style, EnemySpeed en_speed, EnemySize en_size, EnemyAggression en_violent_behavior,EnemyPlanes num_of_enemy_planes, EnemyTanks num_of_enemy_tanks, Mission num_of_planes_to_kill, Mission num_of_tanks_to_kill)
        {
            number_of_levels++;
            level_number = number_of_levels;

            level_name = level_name_str;

            level_time_limit_in_minutes = time_limit_in_minutes;

            player_plane = AllModels.models[(int)pl_model];
            
            if(player_plane.missile_index!= ModelIndex.None)
                player_missile = AllModels.models[(int)player_plane.missile_index];
            else
                player_missile = AllModels.models[(int)ModelIndex.Missile1];

            enemy_plane = AllModels.models[(int)en_model];


            enemy_AI = en_artificial_inteligence;
            enemy_shooting_style = en_shooting_style;

            number_of_enemy_planes=(int)num_of_enemy_planes;
            number_of_enemy_tanks=(int)num_of_enemy_tanks;
            number_of_enemy_planes_to_kill = (int)num_of_planes_to_kill;
            number_of_enemy_tanks_to_kill = (int)num_of_tanks_to_kill;

            enemy_firing_delay = (double)en_violent_behavior;
            enemy_speed = default_enemy_speed * (double)en_speed/100; // divide by 100 because it is in percentage units
            enemy_size = en_size;

            create_level_texts();

        }

        string get_random_well_done_text()
        {
            return (well_done_texts[rnd.Next(well_done_texts.Length - 1)]);
        }
        
        private void create_level_texts()
        {
            string str="";

            str += "Level " + level_number.ToString() + "\n";

            str += "\"" + level_name + "\"\n";

            string enemy_type_str = " plane";
            if (enemy_AI == AI.Insect)
                enemy_type_str = " monster";

            if (number_of_enemy_planes_to_kill > 0)
            {
                str += "Shoot down " + number_of_enemy_planes_to_kill.ToString() + enemy_type_str;
                if (number_of_enemy_planes_to_kill > 1)
                    str += "s\n";
                else
                    str += "\n";
            }


            string tanks_str = " tanks\n";
            if(number_of_enemy_tanks_to_kill==1)
                tanks_str=" tank\n";
            
            if (number_of_enemy_tanks_to_kill > 0)
                str += "Destroy " + number_of_enemy_tanks_to_kill.ToString() + tanks_str;


            if (number_of_enemy_planes > 1)
                enemy_type_str += "s";

            str += "It is you against " + number_of_enemy_planes.ToString() + enemy_type_str + " !\n";

            if (level_time_limit_in_minutes <= 0)
                str += "There is no time limit\n";
            else
                str += "You must complete your mission within " + level_time_limit_in_minutes.ToString() + " minutes !\n";


            str += "Good luck !\n";

            str += "Press Continue to go to the next level";

            level_text = str;

        }

        //loading the missile is a bit different since
        //if enemy_plane.missile_index == ModelIndex.None
        //we use the enemy model also as the missile ! we simply resize the model
        uint load_enemy_missile()
        {
            if (enemy_plane.missile_index != ModelIndex.None)
            {
                Model missile = AllModels.models[(int)enemy_plane.missile_index];
                missile.load(false);
                return( missile.object_handle);
            }

            uint missile_obj = Game.object_create_copy(enemy_plane.object_handle, _3D.NO);

            //set the missile object 4 times smaller than the enemy (4 times in each dimension)
            double[] scale = new double[3];
            _3D.STATE_object_get_scale(missile_obj, scale);
            scale[0] *= 0.25;
            scale[1] *= 0.25;
            scale[2] *= 0.25;
            _3D.STATE_object_set_scale(missile_obj, scale);
            _3D.STATE_object_disable(missile_obj); //this is the master copy so we disable it

            return (missile_obj);
        }

        public void load_level_models()
        {
            //Note that except the player plane, all the other objects are used as master copies
            //so by default they are disabled. When we use them. For example when we launch a missile
            //we simply duplicate the object. The master copy is always disabled (meaning not seen)
            
            player_plane.load(false);
            player_missile.load(false); //this is the master copy. When we launch a missile we duplicate the muster copy. So the master copy is alwyes disabled
            enemy_plane.load(false); //this is the master copy
            enemy_plane.increase_size((double)enemy_size);

            enemy_missile_obj = load_enemy_missile();

            bomb.load(false);
            //_3D.STATE_object_disable(bomb.object_handle); //this is the master copy. When we fire a bomb we duplicate the muster copy. So the master copy is alwyes disabled


            explosion.load(false);
            tank.load(false);
            tank_destroyed.load(false);

            alternative_plane.load(false);
            
        }

        // This function is called before we move to the next level
        //
        //since by default all the objects except the palyer plane are disabled
        //we just need to disable the player plane
        public void disable_level_objects()
        {
            player_plane.enable(false);
            alternative_plane.enable(false); //in the case we switched to the alternative plane
        }

        public TimeSpan get_time_passed()
        {
            DateTime now = DateTime.Now;
            TimeSpan time_passed = now - level_start_time;

            return (time_passed);

        }
        
        public bool is_level_time_over(out string time_left_str, out TimeSpan time_left)
        {
            time_left_str = "";
            time_left = new TimeSpan();

            if (level_time_limit_in_minutes <= 0)
                return (false);
            
            DateTime now = DateTime.Now;
            TimeSpan time_passed = now - level_start_time;

            time_left = get_time_left(time_passed, level_time_limit_in_minutes);

            time_left_str = level_get_time_left_string(time_left);

            if (time_passed.TotalMinutes >= level_time_limit_in_minutes)
                return (true);

            return (false);
        }

        TimeSpan get_time_left(TimeSpan time_passed, double time_limit_in_minutes)
        {
            TimeSpan level_time = new TimeSpan(0, 0, 0, 0, (int)(time_limit_in_minutes * 60000));

            TimeSpan time_left = level_time - time_passed;

            return (time_left);

        }

        string level_get_time_left_string(TimeSpan time_left)
        {

            if (time_left.TotalSeconds <= 0)
                return ("00:00");

            string minutes = time_left.Minutes.ToString().PadLeft(2, '0');
            string seconds = time_left.Seconds.ToString().PadLeft(2, '0');

            return (minutes + ":" + seconds);
        }

    }

    //not in use
    public class Sound
    {
        string file_name;
        int volume;
        uint object_attached;
        double distance_reach;

        public uint sound_handle;

        public Sound(string file, uint obj, int sound_volume, double sound_distance_reach)
        {
            file_name = file;
            volume = sound_volume;
            object_attached = obj;
            distance_reach = sound_distance_reach;
        }

        uint Load()
        {
            sound_handle = _3D.STATE_sound_load("..\\..\\..\\..\\sound\\" + file_name, object_attached, distance_reach);
            if (sound_handle == 0)
                return (0);
            _3D.STATE_sound_set_volume(sound_handle, volume);

            return (sound_handle);
        }

    }


}
